unit FormMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, Menus, StdCtrls, ImgList, Buttons, Spin, ShellAPI,
  math3d, CheckLst, jpeg, Unity_Global,UnitMDC;

Const
APPLICATION_TITLE = 'Open Source: MDC Model Viewer';
APPLICATION_VER = '1.0';
APPLICATION_BY = 'Stucuk';

type
  TFrmMain = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    MainView: TPanel;
    Help1: TMenuItem;
    About1: TMenuItem;
    ColorDialog: TColorDialog;
    ools1: TMenuItem;
    BackgroundColour2: TMenuItem;
    Options1: TMenuItem;
    Disable3DView1: TMenuItem;
    TopBarImageHolder: TImage;
    Label3: TLabel;
    Label21: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    LoadModel1: TMenuItem;
    N2: TMenuItem;
    OpenModelDialog: TOpenDialog;
    Panel3: TPanel;
    PageControl1: TPageControl;
    TabSheet2: TTabSheet;
    TrackBar1: TTrackBar;
    Label13: TLabel;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    FrameBar: TTrackBar;
    Label2: TLabel;
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Idle(Sender: TObject; var Done: Boolean);
    procedure MainViewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MainViewMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure MainViewMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    Procedure SetCaption(Filename : String);
    Procedure SetIsEditable;
    procedure MainViewResize(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure BackgroundColour2Click(Sender: TObject);
    procedure Disable3DView1Click(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LoadModel1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FrameBarChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ModelFilename : String;
    Loading : Boolean;
  end;

var
  FrmMain: TFrmMain;

implementation

uses FormAboutNew,ThreeDView_Engine;

{$R *.dfm}

procedure TFrmMain.Exit1Click(Sender: TObject);
begin
Close;
end;

procedure TFrmMain.Idle(Sender: TObject; var Done: Boolean);
begin
if (not MVEnabled) or (not MDCFile.Loaded) then exit;

FrameBar.Position := MDCFile.Frame;
If MDCFile.Animate then
FrameBarChange(Sender);

DrawFrames;

Done := false;
end;

procedure TFrmMain.FormCreate(Sender: TObject);
begin
Loading := True;
Engine.Main.GAME_FOLDER      := ExtractFileDir(ParamStr(0));
Engine.Main.MOD_FOLDER       := 'RTCW';
Engine.Main.Engine_MODFOLDER := 'RTCW';
SetCaption('');
PageControl1.ActivePage := TabSheet2;

MainViewWidth := MainView.Width;
MainViewHeight := MainView.Height;

Application.OnIdle := Idle;
Init(MainView.Handle);

SetIsEditable;

Loading := False;
TrackBar1.Position := -Trunc(ModelHeight);
end;

procedure TFrmMain.MainViewMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if (not MVEnabled) then exit;

  if Button = mbLeft  then
  begin
    MouseButton :=1;
    Xcoord := X;
    Ycoord := Y;
  end;
  if Button = mbRight then
  begin
    MouseButton :=2;
    Zcoord := Y;
  end;
end;

procedure TFrmMain.MainViewMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if MouseButton = 1 then
  begin
   {$IfDef HELIOS_APP}
   if Camera.ModelMode then
   begin

    xRot := Camera.Model_x_angle;
    yRot := Camera.Model_y_angle;
    xRot := xRot + (Y - Ycoord)/2;  // moving up and down = rot around X-axis
    yRot := yRot + (X - Xcoord)/2;
    Camera.Model_y_angle := YRot;
    Camera.Model_x_angle := XRot;
    Xcoord := X;
    Ycoord := Y;

   end
   else {$EndIf}
   begin
    {$IfDef HELIOS_APP}
    xRot := Camera.x_angle;
    yRot := Camera.y_angle;
    {$EndIf}
    xRot := xRot + (Y - Ycoord)/2;  // moving up and down = rot around X-axis
    yRot := yRot + (X - Xcoord)/2;
    {$IfDef HELIOS_APP}
    Camera.y_angle := YRot;
    Camera.x_angle := XRot;
    {$EndIf}
    Xcoord := X;
    Ycoord := Y;
   end;
  end;
  if MouseButton = 2 then
  begin
  {$IfDef HELIOS_APP}if Camera.ModelMode then{$EndIf}
  begin
    {$IfDef HELIOS_APP}Depth := Camera.Model_Depth;{$EndIf}
    Depth :=Depth - (Y-ZCoord)/3;
    {$IfDef HELIOS_APP}Camera.Model_Depth := Depth;{$EndIf}
    Zcoord := Y;
  end;
  end;
end;

procedure TFrmMain.MainViewMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  MouseButton :=0;
  MainView.Cursor := crCross;
end;

Procedure TFrmMain.SetCaption(Filename : String);
begin

If Filename <> '' then
Caption := ' ' + APPLICATION_TITLE + ' v'+APPLICATION_VER + ' [' +Extractfilename(Filename) + ']'
else
Caption := ' ' + APPLICATION_TITLE + ' v'+APPLICATION_VER;

end;

Procedure TFrmMain.SetIsEditable;
var
Value : Boolean;
begin
Value := ModelLoaded;

ools1.Visible := Value;
Options1.Visible := Value;

if Value then
MainView.Cursor := crCross
else
MainView.Cursor := crDefault;

end;

procedure TFrmMain.MainViewResize(Sender: TObject);
begin
if oglloaded then
ResizeMainView(MainView.Width,MainView.Height);
end;

procedure TFrmMain.About1Click(Sender: TObject);
var
  frm: TFrmAbout_New;
begin
  frm:=TFrmAbout_New.Create(Self);
  frm.Visible:=False;
  Frm.Image1.Picture := TopBarImageHolder.Picture;
  frm.Label2.Caption := APPLICATION_TITLE + ' v' + APPLICATION_VER;
  frm.label1.Caption := frm.label1.Caption + APPLICATION_BY;
  frm.ShowModal;
  frm.Close;
  frm.Free;
end;

procedure TFrmMain.BackgroundColour2Click(Sender: TObject);
begin
ColorDialog.Color := TVector3fToTColor(BGColor);
if ColorDialog.Execute then
BGColor := TColorToTVector3f(ColorDialog.Color);
end;

procedure TFrmMain.Disable3DView1Click(Sender: TObject);
begin
MVEnabled := not MVEnabled;
Disable3DView1.Checked := not MVEnabled;

if not MVEnabled then // no point refreshing if opengl is on
MainView.Refresh;
end;

procedure TFrmMain.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
{$IfDef HELIOS_APP}
keys[Key] := False;
{$EndIf}
//Cons.EvalKeys(Keys);
end;

procedure TFrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//if char(key) = '\' then
//showmessage(inttostr(Key));
{$IfDef HELIOS_APP}
keys[Key] := True;
lastKeyPress := GetTickCount;
{$EndIf}

{w=87
s=63    }
end;

procedure TFrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
{$IfDef HELIOS_APP}
DestroyHelios;
{$EndIf}
end;



procedure TFrmMain.LoadModel1Click(Sender: TObject);
begin

If OpenModelDialog.Execute then
begin
MDCFile.Loaded := False;
MDCFile.Animate := False;
FrameBar.Position := 0;
FrameBar.Max := 0;

LoadMDC(MDCFile,OpenModelDialog.FileName);

If not MDCFile.Loaded then exit;

SetCaption(Extractfilename(OpenModelDialog.FileName));

Engine.ShaderManagerModel.RequiredShaders.Clear;

AddMDCShaders(MDCFile);

Engine.ShaderManagerModel.ReadRequiredShaders;

AssignMDCShaders(MDCFile);

FrameBar.Max := MDCFile.Header.ulNumFrames-1;
FrameBarChange(Sender);
end;

end;

procedure TFrmMain.TrackBar1Change(Sender: TObject);
begin
ModelHeight := -TrackBar1.Position;
end;

procedure TFrmMain.SpeedButton1Click(Sender: TObject);
begin
MDCFile.Animate := True;
end;

procedure TFrmMain.SpeedButton2Click(Sender: TObject);
begin
MDCFile.Animate := False;
end;

procedure TFrmMain.FrameBarChange(Sender: TObject);
begin
Label2.Caption := 'Frames: ' + inttostr(FrameBar.Position) + '/' + inttostr(MDCFile.Header.ulNumFrames-1);

If MDCFile.Animate then exit;

MDCFile.Frame     := FrameBar.Position;
If FrameBar.Position + 1 < MDCFile.Header.ulNumFrames then
MDCFile.NextFrame := FrameBar.Position +1
else
MDCFile.NextFrame := 0;

ProcessVertexModel(MDCFile);

end;

end.
